diff --git a/website/apps/media/data.scm b/website/apps/media/data.scm
index 5796c66..6024d56 100644
--- a/website/apps/media/data.scm
+++ b/website/apps/media/data.scm
@@ -89,16 +89,16 @@ distribution.")
    (screenshot
     #:title "GNOME"
     #:slug "gnome"
-    #:image (guix-url "static/media/img/gnome-totem-epiphany.png")
-    #:preview (guix-url "static/media/img/gnome-totem-epiphany.mini.png")
-    #:caption "Control your computer with the GNOME desktop environment")
+    #:image (guix-url "static/media/img/gnome.png")
+    #:preview (guix-url "static/media/img/gnome.mini.png")
+    #:caption "GNOME desktop environment")
 
    (screenshot
     #:title "Xfce"
     #:slug "xfce"
-    #:image (guix-url "static/media/img/guixsd-xfce-icecat-emacs.png")
-    #:preview (guix-url "static/media/img/guixsd-xfce-icecat-emacs.mini.png")
-    #:caption "The Xfce desktop environment with GNU Emacs and IceCat")
+    #:image (guix-url "static/media/img/xfce.png")
+    #:preview (guix-url "static/media/img/xfce.mini.png")
+    #:caption "Xfce desktop environment")
 
    (screenshot
     #:title "Virtual machine"
diff --git a/website/static/media/img/gnome-totem-epiphany.mini.png b/website/static/media/img/gnome-totem-epiphany.mini.png
deleted file mode 100644
index 791053962ce65dd436eced70300bd33a8d46b322..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/website/static/media/img/gnome-totem-epiphany.png b/website/static/media/img/gnome-totem-epiphany.png
deleted file mode 100644
index cf372ac268b43bc4b8dcd357ee4846f06c55b74f..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/website/static/media/img/gnome.mini.png b/website/static/media/img/gnome.mini.png
new file mode 100644
index 0000000000000000000000000000000000000000..c841577bb06067e9f929f7a3a8909f4c1cb0bee7
GIT binary patch
diff --git a/website/static/media/img/gnome.png b/website/static/media/img/gnome.png
new file mode 100644
index 0000000000000000000000000000000000000000..bef2f1c7109e898c775c8fcb39d13dde910c1281
GIT binary patch
diff --git a/website/static/media/img/guixsd-xfce-icecat-emacs.mini.png b/website/static/media/img/guixsd-xfce-icecat-emacs.mini.png
deleted file mode 100644
index 9ec9caf579836e9bb1f5d1e7e64862b1073c7e05..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/website/static/media/img/guixsd-xfce-icecat-emacs.png b/website/static/media/img/guixsd-xfce-icecat-emacs.png
deleted file mode 100644
index 9c1fa1f020a93cb520bf88dbb290ad340dab48a9..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/website/static/media/img/xfce.mini.png b/website/static/media/img/xfce.mini.png
new file mode 100644
index 0000000000000000000000000000000000000000..caa66c13f13451f87ff3464525ab469cd63ad3a6
GIT binary patch
diff --git a/website/static/media/img/xfce.png b/website/static/media/img/xfce.png
new file mode 100644
index 0000000000000000000000000000000000000000..f16e4305a014dca6c35da6be9b94be5b1ec191cf